	.org $D748

	nop
	jp ProgStart
	.dw 0
	.dw ShellTitle

You = $F000
Him: = $F001

ShellTitle:
	.db	"Rock Paper Scissors v1.1",0

ProgStart:
	call $4A7E		;_clrLCD
	call $4AB1		;_runIndicOff
	ld hl,ShellTitle
	xor a
	ld ($C37D),a	;_curRow
	call _putCenteredString
	ld hl,$Fc70
	call Line
	ld a,9
	ld ($C37D),a
	ld hl,Subtitle
	call _putCenteredString
	ld a,1
	ld (You),a
	ld a,3
	ld (Him),a
KeyLoop:
	ld a,(Him)
	dec a
	or a
	jr nz,Next
	ld a,3
Next:
	ld (Him),a
	call Slow
	call DispSprites
	call $4068
	cp 02h
	jr z,Left
	cp 03h
	jr z,Right
	cp 37h
	jp z,$4A95
	cp 36h
	jr nz,KeyLoop
;Ok, now get the computer's answer.

	ld hl,$FDF0			;Draws a Line
	call Line			;....

	ld a,36				;Set the text column
	ld ($C37D),a		;....

	ld a,(Him)			;Get computer value
	ld b,a				;Hold it in b
	ld a,(You)			;Get your value
	cp b				;See if they're the same
	jr z,Tie			;If so, its a tie.
	dec a
	or a
	jr nz,_nnext
	ld a,3
_nnext:
	cp b
	jr nz,Won
Lost:
	ld hl,LostTitle
	jr _end
Tie:
	ld hl,TieTitle
	jr _end
Won:
	ld hl,WonTitle
_end:
	call _putCenteredString
	call $55AA
	call $4A7E
	jp $4A95

Left:
	ld a,(You)
	dec a
	or a
	jr nz,LoadAndReturn
	ld a,3
	jr LoadAndReturn
Right:
	ld a,(You)
	inc a
	cp 4
	jr nz,LoadAndReturn
	ld a,1
LoadAndReturn:
	ld (You),a
	jp KeyLoop


DispSprites:
	ld a,(You)
	ld b,a
	ld c,6
	call SpritePut
	ld a,(Him)
	ld b,a
	ld c,9
SpritePut:
	ld hl,Sprites-8
	ld de,$0008
SPLoop:
	add hl,de
	djnz SPLoop
	ld d,2
	ld e,c
	jp GridPutSprite

;Line
Line:
	ld a,255
	ld b,16
LLoop:
	ld (hl),a
	inc hl
	djnz LLoop
	ret



Slow:
	ld b,16
LARLoop:
	halt
	djnz LARLoop
	ret

_putCenteredString:
	push hl
_strpixels:
	ld c,0
_strpl:
	ld a,(hl)
	or a
	jr z,_next
	push hl
	call $56A1		;_get_vchar
	ld a,(hl)
	add a,c
	ld c,a
	pop hl
	inc hl
	jr _strpl
_next:
	pop hl
	ld a,128
	sub c
	rra
	ld ($C37C),a
	jp $4AA5

Sprites:

Paper:
	.db %11111111
	.db %10000001
	.db %10111001
	.db %10000001
	.db %10101101
	.db %10000001
	.db %10000001
	.db %11111111

Rock:
	.db %01111110
	.db %10010001
	.db %10000101
	.db %11011001
	.db %10000011
	.db %10101001
	.db %11100001
	.db %01111110

Scissors:
	.db %00011000
	.db %00100100
	.db %00100100
	.db %00011000
	.db %00011000
	.db %00100100
	.db %01000010
	.db %01000010

;===========================================================
; GridPutSprite:                                  [Dan Eble]
;  Puts an aligned sprite at (E, D), where HL -> Sprite
;===========================================================
; IN : D  = y (0-7 inclusive)
;      E  = x (0-15 inclusive)
;      HL-> sprite
;
; OUT: AF, BC, DE, HL, IX modified
; Current total : 28b/567t (not counting ret)
;===========================================================
GridPutSprite:
 
 push hl
 pop ix                 ; ix-> sprite
 srl d                  ; de = 128y+x (16 bytes/row, 8 rows)
 rra
 and $80
 or e                   ; add x offset (remember x <= 15)
 ld e,a
 ld hl,$fc00            ; hl-> video ram
 add hl,de              ; hl-> video ram + offset
 ld b,8                 ; initialize loop counter
 ld de,$10              ; initialize line increment
GPS_Loop
 ld a,(ix+0)            ; get byte from sprite
 ld (hl),a              ; put byte on screen
 inc ix                 ; move to next byte in sprite
 add hl,de              ; move to next line on screen
 djnz GPS_Loop
 ret

Subtitle:
	.db "You---Him",0
LostTitle:
	.db "Loser",0
TieTitle:
	.db "Tie",0
WonTitle:
	.db "Winner",0

.end